<?php

function getSoftphoneFilemap()
{
    return array(
        $GLOBALS['amp_conf']['ASTETCDIR'] => array(
            'softphonepro.conf',
        ),
    );
}

function copySoftphoneFiles()
{
    foreach (getSoftphoneFilemap() as $dst => $files) {
        foreach ($files as $file) {
            $from = dirname(__FILE__) . '/module/' . $file;
            $to = $dst . '/' . $file;

            if (!file_exists($to)) {
                copy($from, $to);
            }
        }
    }
}

function deleteSoftphoneFiles()
{
    foreach (getSoftphoneFilemap() as $dst => $files) {
        foreach ($files as $file) {
            $from = dirname(__FILE__) . '/module/' . $file;
            $to = $dst . '/' . $file;

            if (file_exists($to)) {
                rename($to, $from);
            }
        }
    }
}

function softphoneGet($name = null)
{
    return $name ? getSoftphoneConfigManager()->getParam($name) : getSoftphoneConfigManager()->getParams();
}

function getSoftphoneConfigManager()
{
    require_once dirname(__FILE__) . '/lib/ConfigManager.php';

    return new ConfigManager(dirname(__FILE__) . '/module/softphonepro.conf');
}

function setSoftphoneArray($params)
{
    getSoftphoneConfigManager()->setParams($params);
    needreload();
}

function softphoneGetExtension()
{
    $data = array();
    $data = listUsers();

    $urlTemplate = 'http://online.softphone.pro/install/build?<params>';

    foreach ($data as $key => $info) {
        $params = array(
            getUrlParam('sip_license_key', 'licenseKey'),
            getUrlParam('sip_server', 'sipServer'),
            getUrlParam('sip_domain', 'sipDomain'),
            getUrlParam('sip_proxy', 'sipProxy'),
            "accountName={$info['ext']}",
            "sipUser={$info['ext']}",
            "sipPwd={$info['pass']}",
        );

        $data[$key]['url'] = strtr($urlTemplate, array(
            '<params>' => implode('&', array_filter($params)),
        ));
    }

    return $data;
}

function getUrlParam($name, $key)
{
    $param = softphoneGet($name);

    return empty($param) ? '' : "$key=$param";
}

function listUsers()
{
    $sql = "
    SELECT 
        u.extension AS ext,
        s.data AS pass
    FROM 
        users AS u
    LEFT JOIN
        sip AS s
    ON
        s.id = u.extension AND
        s.keyword = 'secret'
    ORDER BY 
        extension";
    $results = sql($sql, 'getAll', DB_FETCHMODE_ASSOC);

    foreach ($results as $key => $result) {
        if (\checkRange($result['ext'])) {
            $extens[] = $results[$key];
        }
    }

    if (isset($extens)) {

        return $extens;
    } else {
        return array();
    }
}
